// Copyright (c) 2018 WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
//
// WSO2 Inc. licenses this file to you under the Apache License,
// Version 2.0 (the "License"); you may not use this file except
// in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.


///////////////////////////////////
/// Direcotry Listener Endpoint ///
///////////////////////////////////
# Represents directory listener endpoint where used to listen to a directory in the local file system.
#
# + config - Represents necessary configurations that need to configure
public type Listener object {
    private ListenerEndpointConfiguration config;

    public function init(ListenerEndpointConfiguration listenerConfig) {
        self.config = listenerConfig;
        check self.initEndpoint();
    }

    extern function initEndpoint() returns error?;

    public extern function register(typedesc serviceType);

    public extern function start();
};

# Represents configurations that required for directory listener.
#
# + path - Directory path which need to listen
# + recursive - Recursively monitor all sub folders or not in the given direcotry path
public type ListenerEndpointConfiguration record {
    string path;
    boolean recursive = false;
    !...
};
